#include <dlfcn.h>
#include <stdio.h>
#include <stdlib.h>
#include "def.h"

void * load_lib(int argc, char * argv [])
{
    void * lib_handle;
    char lib_path [169];
    char * env_ptr;

    if (argc > 1)
	strcpy(lib_path,argv[1]);
    else
    {
	env_ptr = getenv("SHLPATH");
	if (env_ptr != NULL)
	    strcpy(lib_path,env_ptr);
	else
	{
	    printf("Shared library to use >> ");
	    scanf("%s",lib_path);
	}
    }

    lib_handle = dlopen(lib_path,RTLD_NOW);
    if ( lib_handle == (void *) NULL || lib_handle < (void *) 0 )
    {
	perror("sh_load : error loading library -> ");
	/*  switch(errno) */
/*   	{ */
/*   	    case ENOEXEC : perror("ENOEXEC\n"); break; */
/*   	    case ENOSYM : perror("ENOSYM\n"); break; */
/*   	    case ENOMEM : perror("ENOMEM\n"); break; */
/*   	    case EINVAL : perror("EINVAL\n"); break; */
/*   	    case ENOENT : printf("ENOENT\n"); break; */
/*   	    case EACCES : printf("EACCESS\n"); break; */
/*   	    default : printf("Unknown\n"); */
/*          } */
	exit(1);
    }
    printf("shared library %s loaded\n", lib_path);
	
    return lib_handle;
}

int main(int argc, char ** argv)
{
  void * handle = load_lib(argc,argv);
  void   (*load_data)();
  char ctorname[] = "_GLOBAL__FI_ex11_sl";

  /*  if ((load_data = (void (*)()) dlsym(handle, ctorname)) == (void *) NULL) */
/*      perror("symbol _GLOBAL__FI_ex11_sl not found\n"),exit(1); */
/*    else  */
/*      { */
/*        printf("Initialisation variables globales\n"); */
/*        (*load_data)(); */
/*      } */

  void   (*main1)();
  strcpy(ctorname,"main1");
  if ((main1 = (void (*)()) dlsym(handle, ctorname)) == (void *) NULL)
    perror("symbol main1 not found\n"),exit(1);
  else 
    {
      printf("--------- Execution du main\n");
      (*main1)();
    }

 /*   strcpy(ctorname,"_GLOBAL__FD_ex11_sl"); */
/*    if ((load_data = (void (*)()) dlsym(handle, ctorname)) == (void *) NULL) */
/*      perror("symbol _GLOBAL__FI_ex11_sl not found\n"),exit(1); */
/*    else  */
/*      { */
/*        printf("Destruction variables globales\n"); */
/*        (*load_data)(); */
/*      } */

  dlclose(handle);

  return 0;
}

